// wYDOSxt@CovO

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <direct.h>
#include <sys/types.h>
#include <time.h>
#include <sys/utime.h>

#include "d88.h"

static unsigned char dir[0x200*7];				// Directory (512 x 7sector)
static unsigned char fat[0x3ff];				// 12bit FAT
static unsigned short int fat16[(0x3ff)/3*2];	// 16bit FAT
static unsigned char buffer[0x200*9*80];		// 512byte x 9sector x 80track
static char dirpath[FILENAME_MAX];				// 쐬fBNg

int main(int argc, char *argv[])
{
	int mode=1;

	if (argc<2 && argc>4) {
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: ydoscut image [-d]\n");
		fprintf(stderr, "       -d : not make sub directory\n");
		return 1;
	}

	if (argc==3 && !strcmp(argv[2],"-d")) {
		mode=0;
	}

	D88 disk;
	FILE *fp;

	// t@CJG[ɂȂ
	if (!disk.SetFile(argv[1])) {
		fprintf(stderr, "t@CI[vł܂\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();	// fBXNC[W

	for (int diskno = 0; diskno<numdisk; diskno++) {	// C[W̏

		disk.SelectDisk(diskno);
		sprintf(dirpath,"%03d",diskno);		// fBNg̐
		if (mode) {
			_mkdir(dirpath);				// fBNg쐬
			_chdir(dirpath);				//
			printf("\n[%s] -> %s\n",disk.GetDiskName(),dirpath);
		}

		disk.SetRecordRange(0x01,0x09);		// gbN110ZN^(N=1x2 & N=2 x8)
		disk.ReadDATA(0, 0, 0, 2, 2, fat, sizeof(fat));	// FATǂݍ(track=0,sec=1)
		disk.ReadDATA(0, 0, 0, 6, 2, dir, sizeof(dir));	// fBNgŜǂݍ(track=0,sec=6`)

		// Track 0ȍ~fBXNC[WۂƓǂݍ
		disk.ReadDATA(0, 0, 0, 1, 1, &buffer[0x0000], 0x100);	// Track 0 Sec 1
		disk.ReadDATA(0, 0, 0, 2, 1, &buffer[0x0100], 0x100);	// Track 0 Sec 2 (N=1)
		disk.ReadDATA(0, 0, 0, 2, 2, &buffer[0x0200], 0x200*8);	// Track 0 Sec 2`9 (N=2)
		for (int trk = 1; trk < 80; trk++) {
			disk.ReadDATA(trk, trk>>1, trk&1, 0x01, 0x02, &buffer[0x200*9*trk], 0x200*9);
		}

		// 12bit FAT͈ɂ̂ŁA16bit FATɕϊ
		for (int i=0; i<sizeof(fat)/3*2; i++) {
			fat16[i*2]   = ((short int)fat[i*3+1] & 0x0f)*0x100 + (short int)fat[i*3];
			fat16[i*2+1] =  (short int)fat[i*3+2] * 0x10 + ((short int)fat[i*3+1] >> 4);
		}

		// t@C̐؂o
		for (int fn = 0; fn < sizeof(dir)/0x20; fn++) {
			unsigned char *ent = &dir[fn * 0x20];		// fBNgGg|C^`

			if (ent[0] == 0xe5) continue;	// killꂽt@C̓XLbv
			if (ent[0] == 0x00) break;		// fBNg̍Ō

			char fname[FILENAME_MAX];				// t@C

			int i;
			int fnp = 0;
			for (i=0; i<8; i++) {
				char c = ent[i];		// t@CPo
				if (c==' ') break;
				fname[fnp++] = c;		// t@C\
			}
			if (ent[8] != ' ') {		// gqKvȂt
				fname[fnp++] = '.';
			}
			for (i=8; i<11; i++) {		// 悤Ɋgqo
				char c = ent[i];
				if (c==' ') break;
				fname[fnp++] = c;
			}
			fname[fnp++] = '\0';		// ̍Ō

			int attrb = ent[0x0b];		// 
			int time1 = ent[0x16];		// t@C쐬(8bit)
			int time2 = ent[0x17];		// t@C쐬(8bit)
			int date1 = ent[0x18];		// t@C쐬t(8bit)
			int date2 = ent[0x19];		// t@C쐬t(8bit)
			int crs1  = ent[0x1a];		// JnNX^(8bit)
			int crs2  = ent[0x1b];		// JnNX^(8bit)
			int size1 = ent[0x1c];		// t@CTCY1
			int size2 = ent[0x1d];		// t@CTCY2
			int size3 = ent[0x1e];		// t@CTCY3
			int size4 = ent[0x1f];		// t@CTCY4

			int filetime = time1 + time2 * 0x100;	// 쐬
			int filehh   = time2 >> 3;
			int filemm   = (filetime & 0x07e0) >> 5;
			int filess   = (time1 & 0x1f ) << 1;
			int filedate = date1 + date2 * 0x100;	// 쐬t
			int fileyy   = (date2 >> 1) + 1980;
			int filemn   = (filedate & 0x01e0) >> 5;
			int filedd   = date1 & 0x1f;
			struct tm changetime;
			changetime.tm_sec     = filess;
			changetime.tm_min     = filemm;
			changetime.tm_hour    = filehh;
			changetime.tm_mday    = filedd;
			changetime.tm_mon     = filemn-1;
			changetime.tm_year    = fileyy-1900;
			time_t ts;
			ts = mktime(&changetime);

			short int cruster = crs1  + crs2 * 0x100;	// JnNX^
			int filesize = size1 + size2 * 0x100 + size3 * 0x10000 + size4 * 0x1000000 ;	// t@CTCY

			printf("%-12s %8d %04d/%02d/%02d %02d:%02d:%02d ",fname,filesize,fileyy,filemn,filedd,filehh,filemm,filess);	// t@C\

			if (attrb & 0x20) printf ("A ");
			if (attrb & 0x10) printf ("D ");
			if (attrb & 0x08) printf ("V ");
			if (attrb & 0x04) printf ("S ");
			if (attrb & 0x02) printf ("H ");
			if (attrb & 0x01) printf ("R" );
			printf ("   ");

			if (attrb & 0x08 || attrb & 0x10 ) {
				printf ("\n");
				continue;
			}

			fp = fopen(fname, "wb");	// o̓t@CI[v
			int writesize;

			if (!filesize) {
				fclose(fp);
				printf("\n");
				continue;
			}
			else {
				writesize = filesize;
			}
			
			while (fat16[cruster] != 0x0fff) {
//				printf ("%-2x ",cruster);
				fwrite(&buffer[(cruster+4)*0x400], 1, 0x400, fp);	// 1NX^
				writesize -= 0x400;
				if (ferror(fp)) {
					fprintf(stderr, "t@C߂܂. \n");
					return 1;
				}
				cruster = fat16[cruster];	// FAT`FCH
				if((cruster+4)*0x400 >= 0x200*9*80) {
					fprintf(stderr,"\nNX^jĂ܂.\n");
					break;
				}
			}

			printf("\n");
//			printf ("%-2x\n",cruster);
			fwrite(&buffer[(cruster+4)*0x400], 1, writesize, fp);	// `FC̍Ō
			if (ferror(fp)) {
				fprintf(stderr, "t@C߂܂. \n");
				return 1;
			}

			fclose(fp);		// t@CN[Y
			if (ferror(fp)) {
				fprintf(stderr, "t@C߂܂. \n");
				return 1;
			}

			// ^CX^vύX
			struct utimbuf newtimes;
			newtimes.actime  = ts;
			newtimes.modtime = ts;
			utime(fname,&newtimes);
		}
		if (mode) _chdir("..");		// efBNg
	}
	return 0;
}
